//
//solv.Feq <-
//function(cvec,nvec,mvec){
//
//  Fres <- rep(0,length(cvec))
// # cat(nvec," ")
//  for(i in 1:length(cvec)){
//    F0 <- cvec[i]/nvec[i]
//    F1 <- cvec[i]*(F0+mvec[i])/nvec[i]/(1-exp(-F0-mvec[i]))
//    if(round(cvec[i],6)<round(nvec[i],6)){
//      while(abs(F0-F1)>0.0001 ){
//        F0 <- F1
//        F1 <- cvec[i]*(F0+mvec[i])/nvec[i]/(1-exp(-F0-mvec[i]))
//        if(F0-F1==-Inf) cat("\n",cvec[i]," ",nvec[i]," \n")
//      }
//      Fres[i] <- F1
//    }
//    else{
//      Fres[i] <- 10
//      cat("Warning: catch exceeded tot_num at: ",i," ",
//          round(cvec[i],6)," ",round(nvec[i],6),"\n")
//      }
//  }
//  Fres
//}
//
// C++ version of solv.Feq.r with Rcpp

#include<Rcpp.h>
  
  RcppExport SEXP solv_Feq_rcpp(SEXP cvec, SEXP nvec, SEXP mvec){
  	Rcpp::NumericVector c(cvec);
		Rcpp::NumericVector n(nvec);
		Rcpp::NumericVector m(mvec);
		int nc=c.length();
		Rcpp::NumericVector Fres=Rcpp::NumericVector::create(nc);
		
		
		double F0=0;
		double F1=0;
		for(int i=1;i<=nc;i++){
			F0=c[i]/n[i];
			F1=c[i]*(F0+m[i])/n[i]/(1-exp(-F0-m[i]));
			if(c[i]<n[i]){
				while(abs(F0-F1)>0.0001){
					F0=F1;
					F1=c[i]*(F0+m[i])/n[i]/(1-exp(-F0-m[i]));
			//		if(F0-F1==-Inf) cat("\n",cvec[i]," ",nvec[i]," \n")
				}
				Fres[i]=F1;
			}else{
					Fres[i]=10.0;
			}	
		}

  }
