config.scenarioA.Y90.Y90.aveR <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y90.Y90.R80s <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y90.Y90.R80sHS <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

#####################################################################################################################################

config.scenarioA.Y80.Y80.aveR <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY80))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y80.Y80.R80s <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY80))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y80.Y80.R80sHS <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY80))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

#################################################################################################################################################

config.scenarioA.Y70.Y70.aveR <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY70))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y70.Y70.R80s <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY70))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )
#config.scenarioA.F90.F90.R80s,config.scenarioA.F90.F90.R80sHS
config.scenarioA.Y70.Y70.R80sHS <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY70))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

####################################################################################################################

config.scenarioA.Y60.Y60.aveR <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY60))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y60.Y60.R80s <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY60))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )
#config.scenarioA.F90.F90.R80s,config.scenarioA.F90.F90.R80sHS
config.scenarioA.Y60.Y60.R80sHS <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY60))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )
###########################################################################################################

config.scenarioA.Y50.Y50.aveR <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY50))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y50.Y50.R80s <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY50))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )
#config.scenarioA.F90.F90.R80s,config.scenarioA.F90.F90.R80sHS
config.scenarioA.Y50.Y50.R80sHS <- list(boot=c(1,302),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY50))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )