bootfiledir<-"C:/Users/yukiot/Dropbox/Data3Proj4FRA/"
#proj.data.dir<-"/work/yukiot/projections/"
proj.data.dir<-""
capping1yr<-paste(proj.data.dir,"capping_rule_1yr.csv",sep="")
capping1yr09113yr<-paste(proj.data.dir,"capping_rule_1yr0911.csv",sep="")
capping1yr0911FULL<-paste(proj.data.dir,"capping_rule_1yr0911FULL.csv",sep="")
capping1yr0911FULLY90<-paste(proj.data.dir,"capping_rule_1yr0911FULLY90.csv",sep="")
capping1yr0911FULLY80<-paste(proj.data.dir,"capping_rule_1yr0911FULLY80.csv",sep="")

cat("HERE1\n")
library(ssfuture)
#capping1yr<-"capping_rule_1yr.csv"
config.scenarioA.Y90.Y90.R80sHS <- list(boot=c(1,1),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=rep(30000,302)  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y90.Y90.R80s <- list(boot=c(1,1),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               #pyear.range =list(1952:2009,1952:2009),
                               pyear.range =list(1980:1989,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.Y90.Y90.aveR <- list(boot=c(1,3),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(1,15),   rep(1,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )

config.scenarioA.F80.F90.aveR <- list(boot=c(1,3),     # specification of bootstrap from and to
                   pred.year=31,      # Projection year
                   N=20,              # N of simulations
                   record.NAA=TRUE,  # Is detailed results such as NAA produced?
                   initial.year=2010, # initial year of projection
                   ex.ssb=0,          # Below this number, the population is considered to extinct
                   gm=TRUE,           # Calculate selectivity by geometric or arithmetic mean
                   qt=4,              # Number of season per year
                   MP="MP.CESqt5",    # Function for future harvesting
                   args.mp=list(CES0=NULL,CES.multi=1, # Options for future harvesting
                                    start.regulation.capping=2011,
                                    Fyear1=c(2002,2004),Fyear2=c(2007,2009),

                                    Fyear.list      =list(c(2007,2009),c(2007,2009),c(2007,2009),c(2007,2009)),
                                    Fcur.regime.list=list(c(2010,2010),c(2011,2014),c(2015,2017),c(2018,2041)),
                                    fleet.multi.list=list(rep(1,15),   rep(1,15),   rep(0.8,15),   rep(0.9,15)),

                                    Age.multi.list=list(rep(1,21),rep(1,21),c(rep(1,4),rep(1,17)),rep(1,21)),
                                    catch.capping=list(advance=read.csv(capping1yr0911FULLY90))),
                   Rec.fun="REC.resample3", # Function for future recruitment
                   args.R=list(year.lim=c(1952,2009), # Options for future recruitment
                               qt=4,recruit.qt=1,
                               # pyear.range <- list(c(1950:1960,1970:1980),c(2000:2003))
                               pyear.range =list(1952:2009,1952:2009),
                               # fyear.range <- list(2010:2012,2013:2013))
                               fyear.range=list(2011:2041,c(2010))),
                   HSlimit.tmp=NULL  # Is hockey-stick option used? If yes, input vectors of SSB breakpoint.
                   )



cat("HERE2\n")
bootfiles<-paste(bootfiledir,"/Report_b",formatC(1:302,width=log10(302)+1,flag=0),".sso",sep="")
faafiles<-paste(bootfiledir,"/faab",formatC(1:302,width=log10(302)+1,flag=0),".R",sep="")
mcore<-1
configs.test<-config.scenarioA.Y90.Y90.R80sHS
configs.test<-config.scenarioA.Y90.Y90.R80s
configs.test<-config.scenarioA.Y90.Y90.aveR
configs.test<-config.scenarioA.F80.F90.aveR

#tm.test<-system.time(res<-do.projection.mpi.ss.test(mcore=mcore,bootfiles=bootfiles[1:2],faafiles=faafiles[1:2],config.list=configs.test,MPI=FALSE))

#cat("tm.test=")
#print(tm.test)

tm.test2<-system.time(res<-do.projection.mpi.ss.test(mcore=mcore,bootfiles=bootfiles,faafiles=faafiles,config.list=configs.test,MPI=FALSE))

cat("tm.test2=")
print(tm.test2)