do.projection.ss <-
function(mcore=1, # 並列化するか？mcore>1で並列化
                             bootfiles,faafiles=NULL,config.list,
                             # 以下はアドホックなオプション。デフォルトのままでOK
                             minus2kgSPS=FALSE,faa.multiplier=NULL,by.fleet.CES=NULL){
  #入力しても効かない（上の設定で上書きされる）のは、
  #  partial.catch, HSlimit, Rec.fun, args.R
  if(0){  # そのほかの設定
    #--- 管理方策の設定
    #--- その他
    P.catch=c(2004,2006) # オフの場合
    # P.catch=c(2004,2006),  # P.catchがオンの場合。predictNのpartial.catchオプションに
    # make.partcatchargの出力結果が入る
    by.fleet.CES=NULL
    #---- アドホックなオプション
    minus2kgSPS=FALSE
    target.fleet=1
    limit.bin=46
  # 2kg以下の漁獲をゼロとしたときのオプション群
    #---- アドホックなオプション２
    #                             qt2regulation=FALSE, # SPSの10から12月のFをゼロとする==>もう使えない
    faa.multiplier=NULL # faa.arrayに乗じるarray
    # 暫定的にbluefin.predictNの引数からもってきた
    ex.ssb=0
    qt=4
  #-------------------
  }

  #--- 終了条件の設定   -----
  bsres <- list()
  exit.function <- function(){
    save(bsres,file="bsres_rescued.R")
    if(mcore>1) sfStop()
  }
  on.exit(exit.function())

  #--- bootfilesは必須、faafilesもできれば指定する
  bootfiles <- bootfiles[config.list$boot[1]:config.list$boot[2]]
  if(!is.null(faafiles)){
    faafiles <- faafiles[config.list$boot[1]:config.list$boot[2]]
  }
  nboot <- ifelse(!is.null(faafiles),length(faafiles),length(bootfiles))

  #--- configN.listの整備
  config.tmp <- config.list
  configN.list <- list()
  for(i in 1:nboot){
    repfile <- bootfiles[i]
    # faafilesがあった場合、repfileは、faafilesオブジェクト内のものを用いる
    # パスの問題があるが、、。
    if(!is.null(faafiles)){
      a <- load(faafiles[i])
      faa.tmp <- get(a)
    }
    else{
      faa.tmp <- calFAA.ss2(repfile)
    }

    #------------ Ad hoc なオプションによるfaa.tmpの書き換え
    #------------ minus2kgSPSのオプションがオンの場合
    #------------（特定の漁業において、limit.bin以下への漁獲圧がなくなったら？
    if(minus2kgSPS==TRUE){
      target.term <- c(2002,2004.75)
      a <- calTotcatch.select(repfile,target.fleet=target.fleet,target.term=target.term)

      bins <- as.numeric(rownames(a$target.res[[1]]))
      impact.50cm <- array(0,dim=c(length(a$target.res),21,nboot))
      numbers.50cm <- array(0,dim=c(length(a$target.res),21,nboot))
      for(j in 1:length(a$target.res)){
        impact.50cm[j,,i] <- apply(a$target.res[[j]][bins<limit.bin,],2,sum)/apply(a$target.res[[j]],2,sum)
        # 50cm以下の年齢別漁獲尾数の割合
        numbers.50cm[j,,i] <- apply(a$target.res[[j]][bins<limit.bin,],2,sum)
        # 50cm以下の年齢別漁獲尾数
      }
      caa.tmp <- a$datas$caa
      years <- as.numeric(dimnames(caa.tmp$caa.array)[[1]])
      tmp <- years >= target.term[1] & years <= target.term[2]
      caa.tmp$caa.array[tmp,,2] <- caa.tmp$caa.array[tmp,,target.fleet]-numbers.50cm[,,i] # SPSのcaaを削減！
      a$datas$caa$caa.array  <- caa.tmp$caa.array
      faa.tmp <- calFAA.ss2(repfile,age.limit=c(1,2,3,4,5,rep(6,16)),namae=c(0,1,2,3,4,"5-20"),
                             datas=a$datas)
    }

    if(!is.null(by.fleet.CES)){
      faa.tmp <- control.F.byfleet(faa.tmp,fleet.F=by.fleet.CES)
    }

    if(!is.null(faa.multiplier)){
      faa.tmp$faa.array <- faa.tmp$faa.array*faa.multiplier
      faa.tmp$faa <- apply(faa.tmp$faa.array,c(1,2),sum)
    }
    #------------------ faa.tmpの書き換え終わり ---------------------

    # NAA,FAA等を将来予測に入れる用に変換（４半期）
    config.tmp$outdata <- b <- to.quarterbase(outdata=faa.tmp,qt=4)

    #---------- 加入用のパラメータの設定 ----------------------------
    # 加入がBeverton-Holt + logrmal errorの場合。args.R$rec.timing以外の引数はここで計算
    if(config.list$Rec.fun=="REC.beverton.ss"){
 #      para <- getSRpara.ss2(repfile)[[1]]
      para <- getSRpara.ss(repfile)[[1]] ## 2013/05/30
      tmpR <- config.list$args.R
      config.tmp$args.R <- list(steepness=ifelse(is.null(tmpR$steepness),para$steepness,tmpR$steepness),
                                R0=ifelse(is.null(tmpR$R0),exp(para$logR0)*1000,tmpR$R0),
                                Rsigma=ifelse(is.null(tmpR$Rsigma),para$sigmaR,tmpR$Rsigma),
                                B0=ifelse(is.null(tmpR$B0),para$SSB0,tmpR$B0),
                                Rdev.seed=para$Rdev.seed,
                                recruit.qt=tmpR$recruit.qt,
                                resampled=tmpR$resampled,
                                year.lim=tmpR$year.lim)
    }

    # 加入を２つのフェーズに分ける場合。事前のargs.Rの引数は必要ない
    if(config.list$Rec.fun=="REC.twophase"){
      SRtmp <- getSPR.ss2(repfile)[[1]]
      config.tmp$args.R$ssb.threshold <- median(SRtmp$SPB)
      config.tmp$args.R$R.lowerset <- SRtmp$Recruit[config.tmp$args.R$ssb.threshold > SRtmp$SPB]
      config.tmp$args.R$R.upperset <- SRtmp$Recruit[config.tmp$args.R$ssb.threshold < SRtmp$SPB]
    }

    # Hockey-Stickオプションを使う場合
    if(is.null(config.list$HSlimit)){
      config.tmp$HSlimit <- NULL
    }
    else{
      config.tmp$HSlimit <- config.list$HSlimit[i]
      if(is.null(config.list$HSlimit0)){
        config.tmp$HSlimit0 <- NULL
      }else{
        config.tmp$HSlimit0 <- config.list$HSlimit0[i]
      }
    }

    # qt3のオプション(管理の実行前と実行後の２つのフェーズを仮定する）場合。
    # 引数を毎回変える必要ある
    # この場合、to.quarterbase内のfaatは使わない
    if(is.element(config.list$MP,c("MP.CESqt3","MP.CESqt4","MP.CHSfleet"))){
#      if(EPO02Other04==FALSE){
      config.tmp$partial.catch <-
        make.partcatcharg(faa.res=control.F.byfleet(faa.tmp,fleet.F=config.list$args.mp$fleet.multi1),
                          yr.range=config.list$args.mp$Fyear1,gm=config.list$gm)
      config.tmp$args.mp$Fcur1 <- config.tmp$partial.catch$Fmat
      config.tmp$args.mp$Fcur2 <-
          make.partcatcharg(faa.res=control.F.byfleet(faa.tmp,fleet.F=config.list$args.mp$fleet.multi2),
                            yr.range=config.list$args.mp$Fyear2,gm=config.list$gm)$Fmat
      }
    else{
      if(config.list$MP=="MP.hybrid"){
        # 上述の調整を関数化して、ループにする
        for(kk in 1:length(config.list$args.mp)){
          config.tmp$partial.catch <-
            make.partcatcharg(faa.res=control.F.byfleet(faa.tmp,
                                fleet.F=config.list$args.mp[[kk]]$fleet.multi1),
                              yr.range=config.list$args.mp[[kk]]$Fyear1,
                              gm=config.list$gm)
          config.tmp$args.mp[[kk]]$Fcur1 <- config.tmp$partial.catch$Fmat
          config.tmp$args.mp[[kk]]$Fcur2 <-
            make.partcatcharg(faa.res=control.F.byfleet(faa.tmp,
#                                fleet.F=config.list$args.mp[[kk]]$fleet.multi1), 
# 2012.4.23　multi1になっていた。修正multi2に修正 hybridはほとんど使われないので、問題ないか？？
                                fleet.F=config.list$args.mp[[kk]]$fleet.multi2),
                              yr.range=config.list$args.mp[[kk]]$Fyear2,
                              gm=config.list$gm)$Fmat
    }
      }else if(config.list$MP=="MP.CESqt5"){  ## Added to allow multiple F pattern after management start
          config.tmp$args.mp$Fcur.table<-do.call(rbind,lapply(1:length(config.tmp$args.mp$Fcur.regime.list),
                        FUN=function(i){
                          yrs<-seq(from=config.tmp$args.mp$Fcur.regime.list[[i]][1],to=config.tmp$args.mp$Fcur.regime.list[[i]][2]+0.75,by=0.25)
                          Fcur.no<-rep(i,length(yrs))
                          return(data.frame(year=yrs,Fcur.no=Fcur.no))})
                          )
          if(!is.null(config.list$args.mp$fleet.multi.list) && is.list(config.list$args.mp$fleet.multi.list)){
            if(length(config.list$args.mp$fleet.multi.list)!=length(config.tmp$args.mp$Fyear.list) ||
               any(sapply(config.list$args.mp$fleet.multi.list,FUN=function(x){length(x)!=dim(faa.tmp$faa.array)[[3]]}))){
              config.list$args.mp$fleet.multi.list<-lapply(1:length(config.tmp$args.mp$Fyear.list),FUN=function(i){rep(x=1,length.out=dim(faa.tmp$faa.array)[[3]])})
            }
          }else{
            config.list$args.mp$fleet.multi.list<-lapply(1:length(config.tmp$args.mp$Fyear.list),FUN=function(i){return(NULL)})
          }
          config.tmp$partial.catch <-
            make.partcatcharg(faa.res=control.F.byfleet.byAge(faa.tmp,fleet.F=config.list$args.mp$fleet.multi.list[[1]],
                          age.F=config.list$args.mp$Age.multi.list[[1]]),
                          yr.range=config.list$args.mp$Fyear.list[[1]],gm=config.list$gm)
#          config.tmp$args.mp$Fcur1 <- config.tmp$partial.catch$Fmat
#          config.tmp$args.mp$Fcur2 <-
#            make.partcatcharg(faa.res=control.F.byfleet(faa.tmp,fleet.F=config.list$args.mp$fleet.multi2),
#                            yr.range=config.list$args.mp$Fyear2,gm=config.list$gm)$Fmat
         config.tmp$args.mp$Fcur.list<-
          lapply(1:length(config.tmp$args.mp$Fyear.list),
            FUN=function(i){ #cat(i,":,");cat()
              make.partcatcharg(faa.res=control.F.byfleet.byAge(faa.tmp,fleet.F=config.tmp$args.mp$fleet.multi.list[[i]],
                            age.F=config.list$args.mp$Age.multi.list[[i]]),
                            yr.range=config.tmp$args.mp$Fyear.list[[i]],gm=config.list$gm)$Fmat
        })
#          config.tmp$args.mp$Fcur.list<-c(config.tmp$partial.catch$Fmat,config.tmp$args.mp$Fcur.list)
      }
      else{
        # MPが上述のなんでもないとき。partial.catchになんかを入れておかないと動かないので
        config.tmp$partial.catch <- make.partcatcharg(faa.res=faa.tmp,yr.range=c(1990,2000),
                                                       gm=config.list$gm)
      }
    }

    configN.list[[i]] <- config.tmp
  }
  if(mcore==1){
    z <- lapply(configN.list,bluefin.predictN)
  }
  else{
    library(snowfall)
    sfInit(parallel=TRUE,cpus=mcore)
    sfLibrary(sstools)
    sfLibrary(ssfuture)
    z <- sfLapply(configN.list,bluefin.predictN)
    sfStop()
  }

  if(minus2kgSPS==TRUE){
    save(numbers.50cm,file="numbers.50cm.R")
    save(impact.50cm,file="impact.50cm.R")
  }

  bsres <- add.dim(z)
  bsres$Totcatch <- bsres$"Total catch"
  bsres$"Total catch" <- NULL

  cat("end of calc\n")
  invisible(bsres)
}

